/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __M1_MOTOR_PARAMETER_H
#define __M1_MOTOR_PARAMETER_H

/* Includes -----------------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
//(AMT2)
#define RATED_FREQ_M        100             //Ƶ(unit-Hz)
#define RATED_VOLT_M        _IQ18(8.486)    //ѹ(ߵѹЧֵ,unit-V)
#define RATED_CURR_M        _IQ18(0.86)     //(ߵЧֵ,unit-A)
#define ROTOR_FLUX_M        _IQ(0.00793)    //Ŵ(unit-Wb)
#define POLEPARE_M          5               //(unit-1)
#define STATOR_RES_M        _IQ(1.055)      //ӵ(unit-)
#define STATOR_LD_M         _IQ(0.00195)    //תֱ(unit-H)
#define STATOR_LQ_M         _IQ(0.00238)    //תӽ(unit-H)

//(JMT Motor)
//#define RATED_FREQ_M        200          //Ƶ(unit-Hz)
//#define RATED_VOLT_M        _IQ18(17)           //ѹ(ߵѹЧֵ,unit-V)
//#define RATED_CURR_M        _IQ18(4)          //(ߵЧֵ,unit-A)4.0
//#define ROTOR_FLUX_M        _IQ(0.0084)         //Ŵ(unit-Wb)  ֵ/Ƶ
//#define POLEPARE_M          4              //(unit-1)
//#define STATOR_RES_M        _IQ(0.565)           //ӵ(unit-)  1.3/2
//#define STATOR_LD_M         _IQ(0.00042)        //תֱ(unit-H)0.00042
//#define STATOR_LQ_M         _IQ(0.00042)        //תӽ(unit-H)

//(ONK Motor)
//#define RATED_FREQ_M        250          //Ƶ(unit-Hz)
//#define RATED_VOLT_M        _IQ18(17)           //ѹ(ߵѹЧֵ,unit-V)
//#define RATED_CURR_M        _IQ18(5.0)          //(ߵЧֵ,unit-A)
//#define ROTOR_FLUX_M        _IQ(0.0068)         //Ŵ(unit-Wb)
//#define POLEPARE_M          5              //(unit-1)
//#define STATOR_RES_M        _IQ(0.283)          //ӵ(unit-)
//#define STATOR_LD_M         _IQ(0.000245)       //תֱ(unit-H)
//#define STATOR_LQ_M         _IQ(0.000245)       //תӽ(unit-H)

//ӵ+(unit-)
#define STATOR_RES_TOTAL_M  (STATOR_RES_M + (CURR_SAMPLE_RESISTOR_ADC<<6))

/* Exported variables -------------------------------------------------------*/
extern Component_2R_Type  StatVoltRef2R_M;    //תϵѹ(ֵ)
extern Component_2S_Type  StatVoltRef2S_M;    //ྲֹϵѹ(ֵ)
extern Component_2R_Type  StatCurrRef2R_M;    //תϵ(ֵ)
extern Component_3S_Type  StatCurr3S_M;       //ྲֹϵ(ֵ)
extern Component_2S_Type  StatCurr2S_M;       //ྲֹϵ(ֵ)
extern Component_2R_Type  StatCurr2R_M;       //תϵ(ֵ)
extern Struct_Cossin_Type Struct_Cossin_M;    //任ҽṹ
extern  System_Running_Status_Type  RunningStatus_M;//ϵͳ״̬
extern volatile uint16_t System_Status_Global;              // ϵͳ״̬
extern Motor_Base_Type  MBase_M;              // ֵ

/* Exported macro -----------------------------------------------------------*/
/* Exported functions -------------------------------------------------------*/
//
void Motor_Prameter_Define(Motor_Base_Type *Basestruc);

//رĳʼ
void Motor_Status_Initial_M(void);

//ȫֱʼ
void Global_Status_Initial(void);

//ֵ
void Motor_BaseCal_M(Motor_Base_Type *Basestruc);

#endif
