/* Define to prevent recursive inclusion ------------------------------------*/
#ifndef __M5_MOTORSTART_H
#define __M5_MOTORSTART_H

/* Includes -----------------------------------------------------------------*/
/* Exported types -----------------------------------------------------------*/
/* Exported constants -------------------------------------------------------*/
//ǿƶλ
#define FORCE_INJ_FREQ_M                FREQ_SVPWM          //ǿƶλƵ(unit-Hz)
#define FORCE_INJ_CURR_M                _IQ(0.5)            //ǿƶλ(unit-A_per)
#define FORCE_INJ_ANGLE1_M              _IQ(0.0)            //ǿƶλǶ(unit-PU,0-1)0.08333
#define FORCE_INJ_CURR_RAMP_TIME_M      _IQ(0.5)            //ǿƶλʱ(unit-s)
#define RAMP_INJ_STAGE_M                (uint32_t)(FREQ_SVPWM*3) //ǿƶλʱ

//ջ
#define RAMP_INJ_FREQ_M             FREQ_SVPWM              //ջִƵ(unit-Hz)
#define RAMP_INJ_PERIOD_M           _IQ(1.0)/FREQ_SVPWM     //ջ(unit-1s)
#define RAMP_INJ_CURR_INIT_M        _IQ(0.00)               //ջֵ(unit-A_per)
#define RAMP_INJ_CURR_FINAL_M       _IQ(0.5)                //ջֵ(unit-A_per)
#define RAMP_INJ_CURR_RAMP_TIME_M   _IQ(0.1)                //ջʱ(unit-s)
#define RAMP_INJ_SPEED1_M           _IQ(0.05)               //ջת1(unit-rad/s_per)
#define RAMP_INJ_SPEED_RAMP_TIME1_M _IQ(2)                  //ջת1ʱ(unit-s)
#define RAMP_INJ_SPEED2_M           _IQ(0.2)                //ջת2(unit-rad/s_per)
#define RAMP_INJ_SPEED_RAMP_TIME2_M _IQ(2)                  //ջתʱ2(unit-s)
#define RAMP_INJ_STAGE1_M           (uint32_t)(FREQ_SVPWM*2)     //ջתлʱ
#define RAMP_INJ_STAGE2_M           (uint32_t)(FREQ_SVPWM*5)     //ջʱʱ
#define INJECTION_CURRERR_THRESH_M  _IQ(0.5)                //ջ׶εֵ(unit-A/per)

/* Exported variables -------------------------------------------------------*/
extern Motor_IFStart_Type InjStart_M;                       //ƽṹ

/* Exported macro -----------------------------------------------------------*/

/* Exported functions ------------------------------------------------------ */
void Motor_Start_Init_M(void);                  //ǰĳʼ
void Injection_Startup_Para_Init_M (void);      //ջʼ.
void Injection_Startup_Status_Init_M(void);     //ջ״̬ʼ
void Injection_Startup_M(void);                 //ջ

#endif
