/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
void ADC1_2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/* Private variables --------------------------------------------------------*/
/* Variables ----------------------------------------------------------------*/
/******************************************************************************
* Function Name  : ADC1_2_IRQHandler
* Description    : ADC1&2жӦ۲
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void ADC1_2_IRQHandler(void)
{
    if((ADC1->STATR & ADC_FLAG_JEOC) == ADC_FLAG_JEOC) //ADCעжɱ־Ч
    {
        switch (RunningStatus_M)
        {
            case START:
                Injection_Startup_M();//ע
                break;

            case RUN:
                //ȡ
                StatCurr3S_M = Current_Cal_2R(&ADC_M,ADC1);

                //ABתɵתalphabeta
                StatCurr2S_M = Clark_TransForm(&StatCurr3S_M);

                //LBG۲Ƽ
                LBG_EMF_Cal(&StatVoltRef2S_M,&StatCurr2S_M,_IQ(1.0),&LBG_Cal_M,&LBG_Para_M);

                //LBG۲תٺͽǶȼ
                LBG_Speed_Posi_Cal(&LBG_Cal_M,&LBG_Speed_PLL_M,&LBG_Adaptor_M);

                //ȡǶȵҺֵ
                Struct_Cossin_M = TrigonoMetric_Function(LBG_Cal_M.PosiElecPU);

                //תϵ
                StatCurr2R_M = Park_TransForm(&StatCurr2S_M,&Struct_Cossin_M);

                //d
                StatVoltRef2R_M.cd = PID_Calculaion (StatCurrRef2R_M.cd, StatCurr2R_M.cd, &dCurrRegStruc_M);

                //q
                StatVoltRef2R_M.cq = PID_Calculaion (StatCurrRef2R_M.cq, StatCurr2R_M.cq, &qCurrRegStruc_M);

                //dqѹ޷
                StatVoltRef2R_M = ComponentLimit_2Ror2S(&StatVoltRef2R_M,MAX_MODULATION,&(SVPWM_Cal_M.VoltLimMark),Magnitude_table);

                //alphabetaѹֵ
                StatVoltRef2S_M  = Rev_Park_TransForm(&StatVoltRef2R_M , &Struct_Cossin_M);

                //SVPWM㣬ʼ
                SVPWM_Calculation(&SVPWM_Cal_M,&StatVoltRef2S_M,TIM1);

                //ADCʱ̼
                ADC_Trigger(&SVPWM_Cal_M,ADC1,TIM1);
                break;
            default:
                break;
        }

        //ж
        if(Phase_Ins_OverCurrent_Verify(&StatCurr3S_M,&InstPhaseOC_M) == TRUE)
        {
            Protection_SetFault(MOTOR_OVER_CURR_SOFT_M);
            printf("MOTOR_OVER_CURR_SOFT_M=%d\r\n",1111);
        }
        ADC1->STATR = ~(u32)ADC_FLAG_JEOC;//עתɱ־´ж׼
    }
}
