/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/

/* Variables ----------------------------------------------------------------*/
Motor_Base_Type  MBase_M;               //ֵṹ
Component_2R_Type  StatVoltRef2R_M;     //תϵѹ(ֵ)
Component_2S_Type  StatVoltRef2S_M;     //ྲֹϵѹ(ֵ)
Component_2R_Type  StatCurrRef2R_M;     //תϵ(ֵ)
Component_3S_Type  StatCurr3S_M;        //ྲֹϵ(ֵ)
Component_2S_Type  StatCurr2S_M;        //ྲֹϵ(ֵ)
Component_2R_Type  StatCurr2R_M;        //תϵ(ֵ)
Struct_Cossin_Type Struct_Cossin_M;     //任ҽṹ
System_Running_Status_Type  RunningStatus_M;    //ϵͳ״̬
volatile uint16_t System_Status_Global;              // ϵͳ״̬

/******************************************************************************
* Function Name  : Motor_Prameter_Define
* Description    : 
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Motor_Prameter_Define(Motor_Base_Type *Basestruc)
{
    //ֵ
    Basestruc->Fn = RATED_FREQ_M;
    Basestruc->Vn = RATED_VOLT_M;
    Basestruc->In = RATED_CURR_M;
    Basestruc->Flux = ROTOR_FLUX_M;
    Basestruc->Pn = POLEPARE_M;
    Basestruc->Rs = STATOR_RES_M;
    Basestruc->Ld = STATOR_LD_M;
    Basestruc->Lq = STATOR_LQ_M;
    Basestruc->Rstotal = STATOR_RES_TOTAL_M;
}

/******************************************************************************
* Function Name  : Motor_Status_Initial
* Description    : ״̬ʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Motor_Status_Initial_M(void)
{
    //ֵ
    MBase_M.Fn = RATED_FREQ_M;
    MBase_M.Vn = RATED_VOLT_M;
    MBase_M.In = RATED_CURR_M;
    MBase_M.Flux = ROTOR_FLUX_M;
    MBase_M.Pn = POLEPARE_M;
    MBase_M.Rs = STATOR_RES_M;
    MBase_M.Ld = STATOR_LD_M;
    MBase_M.Lq = STATOR_LQ_M;


    //״̬ʼ
    StatVoltRef2R_M.cd = _IQ(0.0);
    StatVoltRef2R_M.cq = _IQ(0.0);
    StatVoltRef2S_M.Alpha = _IQ(0.0);
    StatVoltRef2S_M.Beta = _IQ(0.0);
    StatCurrRef2R_M.cd = _IQ(0.0);
    StatCurrRef2R_M.cq = _IQ(0.0);
    StatCurr3S_M.PhaseA = _IQ(0.0);
    StatCurr3S_M.PhaseB = _IQ(0.0);
    StatCurr3S_M.PhaseC = _IQ(0.0);
    StatCurr2S_M.Alpha = _IQ(0.0);
    StatCurr2S_M.Beta = _IQ(0.0);
    StatCurr2R_M.cd = _IQ(0.0);
    StatCurr2R_M.cq = _IQ(0.0);
}

/******************************************************************************
* Function Name  : Global_Status_Initial
* Description    : ϵͳ״̬͵״̬ĳʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Global_Status_Initial(void)
{
    System_Status_Global |= SPEED_CONTROL_M;  //ϵͳ״̬ʼתģʽ
    System_Status_Global |= FIRST_START_M;    //ϵͳ״̬ʼһ
    RunningStatus_M = IDLE;                   //ϵͳ״̬ʼ
}
