/* Define to prevent recursive inclusion ------------------------------------*/
#ifndef __M6_SPEEDLOOP_H
#define __M6_SPEEDLOOP_H

/* Includes -----------------------------------------------------------------*/
#include "M0_type_and_Constant.h"

/* Exported constants -------------------------------------------------------*/
#define TIMER_CLOCK_FREQ_SPEED      144000000uL     //תٻʹöʱʱƵ(unit-Hz)
#define TIMER_FREQ_SPEED_LOOP       2000            //תٻʱжƵ(unit-Hz)
#define TIMER_PRESCALER_SPEED_LOOP  17              //תٻʱԤƵֵ:18

 //תٻʱֵ
#define TIMER_PERIDO_SPEED_LOOP_u16     ((uint16_t)(TIMER_CLOCK_FREQ_SPEED /(uint32_t)(TIMER_FREQ_SPEED_LOOP\
                                        *(TIMER_PRESCALER_SPEED_LOOP + 1))))
//תٻƵ(unit-Hz)
#define SPEED_LOOP_CAL_FREQ         1000

//תٻPID(x+1)*500usec
#define SPEED_SAMPLE_PID_PERIOD     TIMER_FREQ_SPEED_LOOP/SPEED_LOOP_CAL_FREQ
//תٻƽתټ(x+1)*500usec
#define AVER_SPEED_CAL_PERIOD       TIMER_FREQ_SPEED_LOOP/SPEED_LOOP_CAL_FREQ

/* Exported variables -------------------------------------------------------*/
/* Exported macro -----------------------------------------------------------*/

/* Exported functions -------------------------------------------------------*/
void Timer4_Init(void); //תٴʱʼ

#endif
