/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/
/* Variables ----------------------------------------------------------------*/
extern void Interrupt_Configuration(void);
/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void)
{
    Delay_Init();
    USART1_Init(115200);                //ڳʼ  ʱPB6 
    KEY_AND_LEDIO_Init();               //ָʾIO
    USBDInit();                         //USBʼ
    Motor_Prameter_Define(&MBase_M);    //
    Motor_BaseCal_M(&MBase_M);          //ֵ
    Global_Status_Initial();            //ȫ״̬ʼ

    //PID
    PID_Prameter_Define(&SpeedRegStruc_M,&dCurrRegStruc_M,&qCurrRegStruc_M);

    //PIDֵ
    PID_ParaBase_Cal_M(&MBase_M,&SpeedRegStruc_M,&dCurrRegStruc_M,&qCurrRegStruc_M);

    //LBG۲
    LBG_Parameter_Define(&LBG_Para_M,&LBG_Cal_M,&LBG_SpeedBuffPara_M,\
                    &LBG_Status_M , &LBG_Speed_PLL_M,&LBG_Adaptor_M);

    //LBG۲
    LBG_Paramter_Cal (&MBase_M,&LBG_Para_M,&LBG_Cal_M, &LBG_Speed_PLL_M,\
                      &LBG_SpeedBuffPara_M,&LBG_EMF_InitPara_M,&LBG_Adaptor_M);

    Injection_Startup_Para_Init_M();                        //עʼ
    Protection_and_Emergency_Init();                        //زʼ
    SVPWM_Paramter_Init(&SVPWM_Cal_M,MBase_M.Vbase);        //SVPWMʼ
    SVPWM_Timer_Configure(TIM1);                            //SVPWMʹöʱGPIOADCʼ
    ADC_Parameter_Init(&ADC_M,MBase_M.Ibase);               //ADCʼ
    ADC_Configure(&ADC_M,ADC1,TIM1);                        //ADC
    ADC_Status_Init (&ADC_M,ADC1,TIM1);                     //ADC״̬ʼ

    Timer3_Init();                                          //öʱʼ
    Timer4_Init();                                          //תٻʱʼ
    Interrupt_Configuration();                              //жóʼ

    //ʱʹ
    TIM_Cmd(TIM1, ENABLE);
    TIM_Cmd(TIM4, ENABLE);
    TIM_Cmd(TIM3, ENABLE);

    printf("%d\r\n",LBG_Speed_PLL_M.Kp);
    printf("%d\r\n",LBG_Speed_PLL_M.Ki);
    printf("%d\r\n",LBG_Cal_M.K_WetoPos);
    printf("%d\r\n",LBG_SpeedBuffPara_M.Inv1);
    printf("%d\r\n",LBG_SpeedBuffPara_M.Inv2);
    printf("%d\r\n",LBG_Adaptor_M.Err_CoefT);
    printf("%d\r\n",LBG_Adaptor_M.EMF_CoefT);
    printf("%d\r\n",LBG_EMF_InitPara_M.K_Volt);
    printf("%d\r\n",LBG_EMF_InitPara_M.K1_Curr);
    printf("%d\r\n",LBG_EMF_InitPara_M.K2_Curr);
    printf("%d\r\n",LBG_EMF_InitPara_M.K3_Curr);

    while(1)
    {
        SysDelayOvertimeDispose();  //ʱִк
        Key_Press_Check();          //¼
        Key_Release_Check();        //ͷż
        Motor_Operation_Process();  //
        deal_sendMonitorData();     //ʾݷ
     }
}
